﻿using ProjectAirBomber.Drawnings;
using ProjectAirBomber.Entities;
using System;

namespace ProjectAirBomber.CollectionGenericObjects;

/// <summary>
/// Реализация абстрактной компании - Ангар самолёта
/// </summary>
public class BomberHungarService : AbstractCompany
{
	/// <summary>
	/// Конструктор
	/// </summary>
	/// <param name="picWidth"></param>
	/// <param name="picHeight"></param>
	/// <param name="collection"></param>
	public BomberHungarService(int picWidth, int picHeight, ICollectionGenericObjects<DrawningBomber> collection) : base(picWidth, picHeight, collection)
	{
	}

	protected override void DrawBackgound(Graphics g)
	{
        Pen pen = new(Color.Black);
        for (int i = 0; i < _pictureWidth / _placeSizeWidth; i++)
        {
            for(int j = 0; j < _pictureHeight / _placeSizeHeight; j++)
            {
				g.DrawLine(pen, new(_placeSizeWidth * i, _placeSizeHeight * j), new((int)(_placeSizeWidth * (i + 0.5f)), _placeSizeHeight * j));
				g.DrawLine(pen, new(_placeSizeWidth * i, _placeSizeHeight * j), new(_placeSizeWidth * i, _placeSizeHeight * (j + 1)));
			}
            g.DrawLine(pen, new(_placeSizeWidth * i, _placeSizeHeight * (_pictureHeight / _placeSizeHeight)), new((int)(_placeSizeWidth * (i + 0.5f)), _placeSizeHeight * (_pictureHeight / _placeSizeHeight)));
        }

        
    }

	//protected override void SetObjectsPosition()
	//{
	//	int n = 0;
	//	for (int i = 0; i < _pictureWidth / _placeSizeWidth; i++)
	//	{
	//		for (int j = 0; j < _pictureHeight / _placeSizeHeight; j++)
	//		{
	//			DrawningBomber? drawningBomber = _collection?.Get(n);
	//			n++;
	//			if (drawningBomber != null)
	//			{
 //                   drawningBomber.SetPictureSize(_pictureWidth, _pictureHeight);
 //                   drawningBomber.SetPosition(i * _placeSizeWidth + 5, j * _placeSizeHeight + 5);
	//			}
	//		}
	//	}
	//}

    protected override void SetObjectsPosition()
    {
        int n = 0;
        for (int i = _pictureWidth / _placeSizeWidth; i > 0; i--)
        {
            for (int j = 0; j < _pictureHeight / _placeSizeHeight; j++)
            {
                DrawningBomber? drawningBomber = _collection?.Get(n);
                n++;
                if (drawningBomber != null)
                {
                    drawningBomber.SetPictureSize(_pictureWidth, _pictureHeight);
                    drawningBomber.SetPosition(i * _placeSizeWidth + 5, j * _placeSizeHeight + 5);
                }
            }
        }
    }
}